# zope
from zope.interface import implements
from persistent import Persistent
from DateTime import DateTime
from BTrees.OOBTree import OOBTree

# rating
from iqpp.rating.interfaces import IRating
from iqpp.rating.interfaces import IAnonymousRating

class Rating(Persistent):
    """see IRating.
    """    
    implements(IRating)

    def __init__(self, id, value, user):
        self._id = id
        self._value = value
        self._user = user
        self._timestamp = DateTime()
        
    @property
    def id(self):
        """
        """    
        return self._id

    @property    
    def value(self):
        """
        """
        return self._value

    @property
    def user(self):
        """
        """
        return self._user
        
    @property
    def timestamp(self):
        """
        """
        return self._timestamp

class AnonymousRating(Rating):
    """
    """
    implements(IAnonymousRating)
    
    def __init__(self, id):
        super(AnonymousRating, self).__init__(id, 0, "anonymous")
        self._amountOfRatings = 0
        self._ipaddresses = OOBTree()
        self._scores = OOBTree()

    @property
    def amountOfRatings(self):
        """
        """
        return self._amountOfRatings

    @property    
    def ipaddresses(self):
        """
        """
        return list(self._ipaddresses.keys())

    @property
    def scores(self):
        """
        """
        return self._scores

    def hasRated(self, ipaddress):
        """
        """
        if ipaddress in self._ipaddresses and\
           (DateTime() - self._ipaddresses.get(ipaddress)) < 1:
           return True
        
        return False
        
    def addValue(self, value, score, ipaddress):
        """
        """
        # If given ipaddress has already rated within a particular time range
        # it isn't allowed to rate again.
        if self.hasRated(ipaddress):
            return False
            
        if self._scores.has_key(score) == False:
            self._scores[score] = 0
        self._scores[score] += 1
            
        self._value = ((self._value * self._amountOfRatings) + value) / (self._amountOfRatings + 1)
        self._amountOfRatings += 1            
        self._ipaddresses[ipaddress] = DateTime()
        return True