# Zope imports
from AccessControl import Unauthorized

# zope imports
from zope.interface import directlyProvides
from zope.component import provideUtility, queryUtility

# test imports
from base import RatingTestCase

# iqpp.rating imports
from iqpp.rating.interfaces import IRatingDefinition    
from iqpp.rating.definition import RatingDefinition

class TestDefinition(RatingTestCase):

    def afterSetUp(self):
        sc = [("1", 1.0), ("2", 2.0), ("3", 3.0), ("4", 4.0),  ("5", 5.0),  ("6", 6.0)]
        score = RatingDefinition("Score", sc, "The Score for a Paper")
        provideUtility(score, IRatingDefinition, name='score')

    def testQueryDefinition(self):
        definition = queryUtility(IRatingDefinition, "score")
        
        self.assertEqual(True, definition.isValidScore("3"))
        self.assertEqual(False, definition.isValidScore("42"))
                        
def test_suite():
    from unittest import TestSuite, makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestDefinition))        
    return suite
