import os, sys
import glob
import doctest
import unittest
from Globals import package_home
from base import RatingFunctionalTestCase
from Testing.ZopeTestCase import FunctionalDocFileSuite as Suite

from iqpp.rating.config import GLOBALS

# from utils import configurationSetUp, configurationTearDown, optionflags

OPTIONFLAGS = (doctest.REPORT_ONLY_FIRST_FAILURE |
               doctest.ELLIPSIS |
               doctest.NORMALIZE_WHITESPACE)

def list_doctests():
  home = package_home(GLOBALS)
  return [filename for filename in
          glob.glob(os.path.sep.join([home, '*.txt']))]

def test_suite():
  filenames = list_doctests()
  return unittest.TestSuite(
      [Suite(os.path.basename(filename), 
             # setUp=configurationSetUp,
             optionflags=OPTIONFLAGS,
             package='iqpp.rating',
             test_class=RatingFunctionalTestCase)
       for filename in filenames])